# This is a Guess the Letter game by PMP.
# This version (03) adds error checking for the player's input and better output formatting.


import random   # This imports a module to add randomizing functions to the basic functions available in Python.

minNumber = 0   # This sets the lower limit for the random number to be chosen by the computer.
maxNumber = 25  # This sets the upper limit for the random number to be chosen by the computer.
maxGuesses = 6  # This sets the maximum number of guesses allowed to 6.
letterList = ['a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z']

print('\n' + '*' * 26 + '\n*' + ' ' * 24 + '*\n*  Letter Guessing Game  *\n*' + ' ' * 24 + '*\n' + '*' * 26 + '\n\n')
# At the start of the game, this gives a title surrounded by asterisks.
# Note that  '*' * 26  means a string of 26 asterisks,  ' ' * 24  means a string of 24 spaces,  and  \n  means 'start a new line'.

print('Hello! What is your name?')
playerName = input()  # This allows the player to enter his/her name.

number = random.randint(minNumber, maxNumber)  # This sets the variable 'number' to an integer between 'minNumber' and 'maxNumber' inclusive.
guessesTaken = 0                               # This sets the counter for the number of guess taken to zero.
letter = letterList[number]                    # This picks a random letter from 0-25 (N.B. not 1-26) in the list of letters.

print('\nWell, ' + playerName + ', I\'m thinking of a letter between A and Z.')
# \' allows an apostrophe to be used within a string.

while guessesTaken < maxGuesses:  # This 'while' loop runs as long as the number of guesses taken is less than the maximum number of guesses.

    print()                            # This prints a blank line.
    if maxGuesses - guessesTaken > 1:  # This 'if' statement gives an output if the player has more than one guess left.
        print('You have ' + str(maxGuesses - guessesTaken) + ' guesses left.')
    else:                              # This 'else' statement matches the 'if maxGuesses - guessesTaken > 1:' statement above.
        print('You have 1 guess left.')
    print('What do you think my letter is?')

    while True:                       # This 'while' loop checks whether the player's guess is valid (i.e. a letter).
        guess = input()               # This allows the player to enter a guess.
        guess = str.lower(guess)      # This converts the player's entry to lower case.
        if not guess in letterList:   # This checks to see if the guess is a letter.
            print('You must enter a letter from A to Z - try again.')
        else:
            break
    # This point marks the end of the 'while True:' loop.

    guessesTaken = guessesTaken + 1  # This adds one to the counter for number of guesses taken.

    if guess < letter:         # This 'if' statement gives an output if the player's guess is before the computer's chosen letter.
        print('Your guess is too early in the alphabet.')

    elif guess > letter:       # This 'elif' statement gives an output if the player's guess is after the computer's chosen letter.
        print('Your guess is too far on in the alphabet.')

    elif guess == letter:      # This 'elif' statement gives an output if the player's guess is equal to the computer's chosen letter.
        break                  # If the guess is equal to the letter, this 'break' stops any more guesses being asked for.

# This point marks the end of the 'while guessesTaken < maxGuesses:' loop.

if guess == letter:          # This 'if' statement gives an output depending on whether the player got the computer's letter right or not.
    print('\nWell done, ' + playerName + '! You guessed my letter in ', end='')  # , end=''  makes the next 'print' function continue on the same line.
    if guessesTaken > 1:     # This 'if' statement gives an output depending on how many guesses the player took.
        print(str(guessesTaken) + ' guesses!')
    else:                    # This 'else' statement matches the 'if guessesTaken > 1:' statement above.
        print('one guess!')
else:                        # This 'else' statement matches the 'if guess == number:' statement above.
    print('\nBad luck. The letter I was thinking of was ' + str.upper(letter) + '.')
