# This is a Guess the Number game from 'Invent Your Own Computer Game With Python' adapted by PMP.
# This version (01) is the original program.


import random  # This imports a module to add randomizing functions to the basic functions available in Python.

print()                              # This prints a blank line.
print('*' * 26)                      # This prints a string of 26 asterisks.
print('*' + ' ' * 24 + '*')          # This prints an asterisk, then a string of 24 spaces, then an asterisk.
print('*  Number Guessing Game  *')  # This prints the game's title with an asterisk and two spaces on each side.
print('*' + ' ' * 24 + '*')          # This prints an asterisk, then a string of 24 spaces, then an asterisk.
print('*' * 26)                      # This prints a string of 26 asterisks.
print()                              # This prints a blank line.

print('Hello! What is your name?')
playerName = input()  # This allows the player to enter his/her name.

number = random.randint(1, 20)  # This sets the variable 'number' to an integer between 1 and 20 inclusive.
guessesTaken = 0                # This sets the counter for the number of guess taken to zero.

print('Well, ' + playerName + ', I\'m thinking of a number between 1 and 20.')
# N.B. \' allows an apostrophe to be used within a string.

while guessesTaken < 6:     # This 'while' loop checks that the number of guesses taken is less than 6.
    print('Take a guess.')  # N.B. There are 4 spaces in front of 'print' to show that this section of the program is part of the 'while' loop.
    guess = input()         # This allows the player to enter a guess.
    guess = int(guess)      # This converts the player's entry from a string to an integer.

    guessesTaken = guessesTaken + 1  # This adds one to the counter for number of guesses taken.

    if guess < number:      # This 'if' statement gives an output if the player's guess is less than the computer's chosen number.
        print('Your guess is too low.')

    elif guess > number:    # This 'elif' statement gives an output if the player's guess is greater than the computer's chosen number.
        print('Your guess is too high.')
        # N.B. 'elif' means 'else if'.

    elif guess == number:   # This 'elif' statement gives an output if the player's guess is equal to the computer's chosen number.
        break               # If the guess is equal to the number, this stops any more guesses being asked for.

if guess == number:  # This 'if' statement gives an output if the player's guess equals the computer's number.
    print('Well done, ' + playerName + '! You guessed my number in ' + str(guessesTaken) + ' guesses!')
    # N.B. str() converts a numeric variable to a string.
else:                # This 'else' statement gives an output if the player's guess is NOT equal to the computer's number.
    print('Bad luck. The number I was thinking of was ' + str(number) + '.')
