# This is a Guess the Number game from 'Invent Your Own Computer Game With Python' adapted by PMP.
# This version (02) uses variables for the limits for the numbers chosen by the computer and for the maximum number of guesses; it also shortens the coding of the title display.


import random   # This imports a module to add randomizing functions to the basic functions available in Python.

minNumber = 1   # This sets the lower limit for the random number to be chosen by the computer.
maxNumber = 20  # This sets the upper limit for the random number to be chosen by the computer.
maxGuesses = 6  # This sets the maximum number of guesses allowed to 6.

print('\n' + '*' * 26 + '\n*' + ' ' * 24 + '*\n*  Number Guessing Game  *\n*' + ' ' * 24 + '*\n' + '*' * 26 + '\n\n')
# At the start of the game, this gives a title surrounded by asterisks.
# Note that  '*' * 26  means a string of 26 asterisks,  ' ' * 24  means a string of 24 spaces,  and  \n  means 'start a new line'.

print('Hello! What is your name?')
playerName = input()  # This allows the player to enter his/her name.

number = random.randint(minNumber, maxNumber)  # This sets the variable 'number' to an integer between 'minNumber' and 'maxNumber' inclusive.
guessesTaken = 0                               # This sets the counter for the number of guess taken to zero.

print('Well, ' + playerName + ', I\'m thinking of a number between ' + str(minNumber) + ' and ' + str(maxNumber) + '.')
# \' allows an apostrophe to be used within a string.
# str() converts a numeric variable to a string variable (so that it can be displayed correctly with 'print').

while guessesTaken < maxGuesses:     # This 'while' loop runs as long as the number of guesses taken is less than the maximum number of guesses.
    print('Take a guess.')
    guess = input()                  # This allows the player to enter a guess.
    guess = int(guess)               # This converts the player's (string) entry to an integer.
    guessesTaken = guessesTaken + 1  # This adds one to the counter for number of guesses taken.

    if guess < number:         # This 'if' statement gives an output if the player's guess is less than the computer's chosen number.
        print('Your guess is too low.')
        if guess < minNumber:  # This 'if' statement gives an output if the player's guess is less than 'minNumber'.
            print('You\'ve wasted this guess, as your number is below the minimum possible choice for the computer.')

    elif guess > number:       # This 'elif' statement gives an output if the player's guess is greater than the computer's chosen number.
        print('Your guess is too high.')
        if guess > maxNumber:  # This 'if' statement gives an output if the player's guess is greater than 'maxNumber'.
            print('You\'ve wasted this guess, as your number is above the maximum possible choice for the computer.')

    elif guess == number:      # This 'elif' statement gives an output if the player's guess is equal to the computer's chosen number.
        break                  # If the guess is equal to the number, this 'break' stops any more guesses being asked for.

if guess == number:  # This 'if' statement gives an output if the player's guess equals the computer's number.
    print('Well done, ' + playerName + '! You guessed my number in ' + str(guessesTaken) + ' guesses!')
else:                # This 'else' statement matches the 'if guess == number:' statement above.
    print('Bad luck. The number I was thinking of was ' + str(number) +'.')
