# This is a Guess the Number game from 'Invent Your Own Computer Game With Python' adapted by PMP.
# This version (04) adds the ability for the player to choose whether or not to continue playing after one game.


import random   # This imports a module to add randomizing functions to the basic functions available in Python.

minNumber = 1   # This sets the lower limit for the random number to be chosen by the computer.
maxNumber = 20  # This sets the upper limit for the random number to be chosen by the computer.
maxGuesses = 6  # This sets the maximum number of guesses allowed to 6.

print('\n' + '*' * 26 + '\n*' + ' ' * 24 + '*\n*  Number Guessing Game  *\n*' + ' ' * 24 + '*\n' + '*' * 26 + '\n\n')
# At the start of the game, this gives a title surrounded by asterisks.
# Note that  '*' * 26  means a string of 26 asterisks,  ' ' * 24  means a string of 24 spaces,  and  \n  means 'start a new line'.

print('Hello! What is your name?')
playerName = input()  # This allows the player to enter his/her name.

while True:  # This 'while' loop runs as long as the player asks to continue playing after each game.

    number = random.randint(minNumber, maxNumber)  # This sets the variable 'number' to an integer between 'minNumber' and 'maxNumber' inclusive.
    guessesTaken = 0                               # This sets the counter for the number of guess taken to zero.

    print('\nWell, ' + playerName + ', I\'m thinking of a number between ' + str(minNumber) + ' and ' + str(maxNumber) + '.')
    # \' allows an apostrophe to be used within a string.
    # str() converts a numeric variable to a string variable (so that it can be displayed correctly with 'print').

    while guessesTaken < maxGuesses:  # This 'while' loop runs as long as the number of guesses taken is less than the maximum number of guesses.

        print()                            # This prints a blank line.
        if maxGuesses - guessesTaken > 1:  # This 'if' statement gives an output if the player has more than one guess left.
            print('You have ' + str(maxGuesses - guessesTaken) + ' guesses left.')
        else:                              # This 'else' statement matches the 'if maxGuesses - guessesTaken > 1:' statement above.
            print('You have 1 guess left.')
        print('What do you think my number is?')

        while True:                 # This 'while' loop checks whether the player's guess is valid (i.e. a number, not a letter or word).
            guess = input()         # This allows the player to enter a guess.
            try:                    # The 'try' statement allows the program to check whether the player's entry is valid.
                guess = int(guess)  # This tries to treat the player's entry as an integer number.
                break               # If the player's entry is something which can be converted to an integer, then 'break' out of this 'while' loop.
            except ValueError:      # If the player's entry cannot be converted to an integer, then print an error message.
                print('You must enter numbers, not letters - try again.')
        # This point marks the end of the 'while True:' loop.

        guess = int(guess)               # This converts the player's (string) entry to an integer.
        guessesTaken = guessesTaken + 1  # This adds one to the counter for number of guesses taken.

        if guess < number:         # This 'if' statement gives an output if the player's guess is less than the computer's chosen number.
            print('Your guess is too low.')
            if guess < minNumber:  # This 'if' statement gives an output if the player's guess is less than 'minNumber'.
                print('You\'ve wasted this guess, as your number is below the minimum possible choice for the computer.')

        elif guess > number:       # This 'elif' statement gives an output if the player's guess is greater than the computer's chosen number.
            print('Your guess is too high.')
            if guess > maxNumber:  # This 'if' statement gives an output if the player's guess is greater than 'maxNumber'.
                print('You\'ve wasted this guess, as your number is above the maximum possible choice for the computer.')

        elif guess == number:      # This 'elif' statement gives an output if the player's guess is equal to the computer's chosen number.
            break                  # If the guess is equal to the number, this 'break' stops any more guesses being asked for.

    # This point marks the end of the 'while guessesTaken < maxGuesses:' loop.

    if guess == number:          # This 'if' statement gives an output depending on whether the player got the computer's number right or not.
        print('\nWell done, ' + playerName + '! You guessed my number in ', end='')  # , end=''  makes the next 'print' function continue on the same line.
        if guessesTaken > 1:     # This 'if' statement gives an output depending on how many guesses the player took.
            print(str(guessesTaken) + ' guesses!')
        else:                    # This 'else' statement matches the 'if guessesTaken > 1:' statement above.
            print('one guess!')
    else:                        # This 'else' statement matches the 'if guess == number:' statement above.
        print('\nBad luck. The number I was thinking of was ' + str(number) +'.')

    print('\nDo you want another game, ' + playerName + '?')
    newGameYesNo = str.lower(input())                  # 'str.lower' converts a string to lower case.
    if newGameYesNo != 'yes' and newGameYesNo != 'y':  # This 'if' statement ends the program if the player enters anything other than 'yes' or 'y'.
        print('\nThank you for playing \'Guess The Number\', ' + playerName + ".")
        break

# This point marks the end of the outermost 'while True:' loop.
